/*
 *  critsec.c
 *  Threads and CriticalSection
 *  uses structured exception handling MS-spezific
 *  Bernhard Rabe
 *  18.11.2004
 */
 
#include <windows.h>
#include <stdio.h>


CRITICAL_SECTION w_stdout;


DWORD WINAPI Thread(LPVOID data)
{
    int id=*(int*)data,l;
#ifdef CRITSEC
    _try
    {    
        EnterCriticalSection(&w_stdout);
    }
    _except(EXCEPTION_CONTINUE_SEARCH)
    {
        fprintf(stderr,"Exception Enter");
        exit(1);
    }
#endif    
    for(l=0;l<10;l++)
    {
        printf("%c",id);
        Sleep(1); /* Big computation here */
    }
    printf("\n");
#ifdef CRITSEC
    _try
    {
        LeaveCriticalSection(&w_stdout);
    }
    _except(EXCEPTION_CONTINUE_SEARCH)
    {
        fprintf(stderr,"Exception Leave");
        exit(1);
    }
#endif    
    return 0;    
}


int main(int argc, char *argv[])
{
    HANDLE hThread[10];
    int ids[10]={'-','*','+','#','~','$','','%','^',''},i=2,l;
    if(argc>1)
    {
        i=atoi(argv[1]);
        if(i<2 || i> 10)
        {
            printf("Only 2-10 Threads allowed\n");
            printf("Usage: %s   - 2 Threads\nUsage: %s  [2-10] - 2-10 Threads\n");
            exit(1);
        }
    }
#ifdef CRITSEC 
    _try
    {
      InitializeCriticalSection(&w_stdout);
    }
    _except(EXCEPTION_CONTINUE_SEARCH)
    {
        fprintf(stderr,"Exception Initialize");
        exit(1);
    }
#endif    
    for(l=0;l<i;l++)
    {       //CREATE_SUSPENDED
        DWORD id;
        if(NULL==(hThread[l]=CreateThread(NULL,0,Thread,&ids[l],0, &id)))
        {
            fprintf(stderr,"Error creating Thread\n");
            exit(1);
        }            
    }
  
    printf("Waiting for Threads\n");    
    if(WaitForMultipleObjects(i,hThread,TRUE,INFINITE)==WAIT_FAILED)
    {
        fprintf(stderr,"Error waiting for Threads\n");
        exit(1);
    }
    for(l=0;l<i;l++) CloseHandle(hThread[l]);
    
#ifdef CRITSEC
    _try
    {    
      DeleteCriticalSection(&w_stdout);
    }
    _except(EXCEPTION_CONTINUE_SEARCH)
    {
        fprintf(stderr,"Exception Delete");
        exit(1); 
    }
#endif    
    return 0;
}